
<!DOCTYPE html>

<html lang="it">
  <head>
    <meta charset="utf-8" />
    <title>MarkDown &#8212; Introduzione a Sphinx 1.0.0 documentazione</title>
    <link rel="stylesheet" href="../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <script src="../_static/translations.js"></script>
    <link rel="index" title="Indice" href="../genindex.html" />
    <link rel="search" title="Cerca" href="../search.html" />
    <link rel="next" title="Glossario" href="glossario.html" />
    <link rel="prev" title="Scrivere la documentazione" href="scrivere.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="markdown">
<h1>MarkDown<a class="headerlink" href="#markdown" title="Link a questa intestazione">¶</a></h1>
<p>È giunto il momento di parlare nuovamente di <a class="reference internal" href="premessa.html#md-ref"><span class="std std-ref">MarkDown</span></a>.</p>
<p>Come dicevamo Sphinx ha una forte integrazione con rst e riesce a gestire molti
automatismi, però abbiamo anche detto che MarkDown è molto diffuso, perciò può
capitare di avere la necessità di condividere files MarkDown tra Sphinx ed
altri sistemi, o semplicemente disponiamo già di molti testi che non abbiamo
voglia di tradurre.</p>
<p>Per venire incontro a queste esigenze, Sphinx fornisce la possibilità di
integrare testi MarkDown, che però non potranno usufruire di tutte le
prerogative di cui godono i files rst.</p>
<p>Per attivare MarkDown dobbiamo importare il modulo apposito con:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ pip install recommonmark
</pre></div>
</div>
<p>In realtà lo avevamo gia fatto quando abbiamo parlato di <a class="reference internal" href="installazione.html"><span class="doc">Installazione</span></a>.</p>
<p>Poi si debbono fare alcune modifiche al file di configurazione <code class="docutils literal notranslate"><span class="pre">conf.py</span></code> di
cui parleremo tra poco in modo più approfondito. Queste sono le modifiche:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">extensions</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;recommonmark&#39;</span><span class="p">]</span>

<span class="n">source_suffix</span> <span class="o">=</span> <span class="p">{</span>
    <span class="s1">&#39;.rst&#39;</span><span class="p">:</span> <span class="s1">&#39;restructuredtext&#39;</span><span class="p">,</span>
    <span class="s1">&#39;.txt&#39;</span><span class="p">:</span> <span class="s1">&#39;markdown&#39;</span><span class="p">,</span>
    <span class="s1">&#39;.md&#39;</span><span class="p">:</span> <span class="s1">&#39;markdown&#39;</span><span class="p">,</span>
<span class="p">}</span>
</pre></div>
</div>
<p>A questo punto solo aggiungendo il file nel <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">toctree::</span></code>, il documento
verrà aggiunto con la sintassi appropriata.</p>
</div>
<div class="section" id="configurazione">
<h1>Configurazione<a class="headerlink" href="#configurazione" title="Link a questa intestazione">¶</a></h1>
<div class="section" id="il-file-conf-py">
<h2>Il file conf.py<a class="headerlink" href="#il-file-conf-py" title="Link a questa intestazione">¶</a></h2>
<p>La configurazione di Sphinx viene fatta con un file Python di nome <code class="docutils literal notranslate"><span class="pre">conf.py</span></code>
che si trova nella stessa directory del progetto. il comando:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ sphinx-quickstart
</pre></div>
</div>
<p>Ne ha già preparata una versione funzionante con i parametri principali a cui
possiamo aggiungere i parametri di nostra scelta.</p>
<p>La lista completa dei parametri attivabili si trova in questa
<a class="reference external" href="https://www.sphinx-doc.org/en/master/usage/configuration.html">pagina.</a> qui
ne elenchiamo solo alcuni.</p>
<p><strong>extenions</strong> permette di attivare estensioni integrate o di terze parti, ad
esempio:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">extensions</span> <span class="o">=</span> <span class="p">[</span>
    <span class="s1">&#39;recommonmark&#39;</span><span class="p">,</span>
    <span class="s1">&#39;sphinx.ext.autosectionlabel&#39;</span>
<span class="p">]</span>

<span class="n">autosectionlabel_maxdepth</span> <span class="o">=</span> <span class="mi">3</span>
</pre></div>
</div>
<p>attiva due estensioni. La seconda permette di interrogare il parametro
<code class="docutils literal notranslate"><span class="pre">autosectionlabel_maxdepth</span></code> che indica il livello di profondità dell'albero
dell indice.</p>
<p><strong>rst_prolog</strong> e <strong>rst_epilog</strong> permettono di aggiungere un testo fisso a tutte
le pagine rst in testa e/o in coda a ciascuna pagina. Ad esempio</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">rst_epilog</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">Questo documento è sottoposto a licenza creative commons</span>

<span class="s2">.. image:: /_static/creative_commons.png</span>

<span class="s2">.. |my_url| replace:: https://mywebagency.com</span>

<span class="s2">.. |br| raw:: html</span>

<span class="s2">&lt;br /&gt;</span>

<span class="s2">&quot;&quot;&quot;</span>
</pre></div>
</div>
<p>Questa è una posizione buona per inserire direttive che possono essere utili
in tutte le pagine.</p>
<p><strong>smartquotes</strong> esegue la sostituzione automatica dei caratteri di quotatura
<code class="docutils literal notranslate"><span class="pre">&quot;</span></code> e <code class="docutils literal notranslate"><span class="pre">'</span></code> con caratteri tipografici, ma a volte possono essere fastidiosi,
ad esempio se scrivo <code class="docutils literal notranslate"><span class="pre">un</span> <span class="pre">po'</span></code> mi ritrovo scritto <code class="docutils literal notranslate"><span class="pre">un</span> <span class="pre">po&quot;</span></code>. per evitare
posso aggiungere</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">smartquotes</span> <span class="o">=</span> <span class="kc">False</span>
</pre></div>
</div>
</div>
<div class="section" id="il-tema-html">
<h2>il tema html<a class="headerlink" href="#il-tema-html" title="Link a questa intestazione">¶</a></h2>
<p>Sempre nel file <code class="docutils literal notranslate"><span class="pre">conf.py</span></code> c'è la possibilità di scegliere il tema html.</p>
<p>Alcuni temi sono già precaricati con sphinx ed è sufficiente cambiare il
tema 'alabaster' che è quello predefinito con quello scelto, ad esempio</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="c1"># html_theme = &#39;alabaster&#39;</span>
<span class="n">html_theme</span> <span class="o">=</span> <span class="s1">&#39;sphinxdoc&#39;</span>
</pre></div>
</div>
<p>I temi opzionali invece devono essere scaricati con pip e dichiarati nelle
estensioni, ad esempio:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>$ pip install sphinx-rtd-theme
</pre></div>
</div>
<p>e poi in <code class="docutils literal notranslate"><span class="pre">conf.py</span></code> si fanno queste modifiche:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">sphinx_rtd_theme</span>

<span class="n">extensions</span> <span class="o">=</span> <span class="p">[</span>
    <span class="o">...</span>
    <span class="s2">&quot;sphinx_rtd_theme&quot;</span><span class="p">,</span>
<span class="p">]</span>

<span class="n">html_theme</span> <span class="o">=</span> <span class="s2">&quot;sphinx_rtd_theme&quot;</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="documentazione-di-python">
<h1>Documentazione di Python<a class="headerlink" href="#documentazione-di-python" title="Link a questa intestazione">¶</a></h1>
<p>Sphinx dopotutto nasce per documentare i moduli Python, quindi è normale che
ci siamo facilitazioni apposite per questo scopo.</p>
<p>C'è comunque da dire che Python ci aiuta molto, infatti ha integrato nel
linguaggio stesso un sistema di introspezione della documentazione molto
efficace su cui Sphinx si appoggia per generare la documentazione automatica.</p>
<p>Troviamo tutto nella pagina di <a class="reference external" href="https://www.sphinx-doc.org/en/master/usage/extensions/autodoc.html#module-sphinx.ext.autodoc">autodoc</a></p>
<p>Per prima cosa doppiamo aggiungere l'apposita estensione.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">extensions</span> <span class="o">=</span> <span class="p">[</span>
    <span class="o">...</span>
    <span class="s1">&#39;sphinx.ext.autodoc&#39;</span><span class="p">,</span>
<span class="p">]</span>
</pre></div>
</div>
<p>poi bisogna che il modulo da documentare sia disponibile nel percorso di
ricerca di Python.</p>
<p>Se il file da documentare risiede nella stessa cartella del progetto Sphinx,
posso modificare il file <code class="docutils literal notranslate"><span class="pre">conf.py</span></code> aggiungendo queste righe:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s1">&#39;.&#39;</span><span class="p">))</span>
</pre></div>
</div>
<p>A questo punto nel file in cui vogliamo che compaia la documentazione possiamo
semplicemente aggiungere la direttiva:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">..</span> <span class="n">automodule</span><span class="p">::</span> <span class="n">mylib</span>
    <span class="p">:</span><span class="n">members</span><span class="p">:</span>
</pre></div>
</div>
<p>in cui <code class="docutils literal notranslate"><span class="pre">mylib</span></code> è il nome della libreria da documentare.</p>
</div>
<div class="section" id="estensioni-di-sphinx">
<h1>Estensioni di Sphinx<a class="headerlink" href="#estensioni-di-sphinx" title="Link a questa intestazione">¶</a></h1>
<p>Puo capitare che le funzionalità di cui abbiamo bisogno per la nostra
documentazione non sia immediatamente presente nella configurazione standard.</p>
<p>Sphinx dispone di molte estensioni, e nel corso di questa presentazione
ci è già capitato di utilizzarne.</p>
<p>Alcune sono già disponibili con la installazione standard, altre invece sono
di terze parti e prima di poterle utilizzare devono essere installate.</p>
<p>Nella <a class="reference external" href="http://www.sphinx-doc.org/en/master/usage/extensions/index.html">pagina</a>
dedicata alle estensioni si possono trovare maggiori informazioni, compresa
la lista delle estensioni disponibili ed anche la documentazione per sviluppare
le proprie se non si trova quella adatta al nostro scopo.</p>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">Introduzione a Sphinx</a></h1>








<h3>Navigazione</h3>
<p class="caption"><span class="caption-text">Contenuto:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="premessa.html">Premessa</a></li>
<li class="toctree-l1"><a class="reference internal" href="installazione.html">Installazione di Spinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="scrivere.html">Scrivere la documentazione</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">MarkDown</a></li>
<li class="toctree-l1"><a class="reference internal" href="#configurazione">Configurazione</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#il-file-conf-py">Il file conf.py</a></li>
<li class="toctree-l2"><a class="reference internal" href="#il-tema-html">il tema html</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="#documentazione-di-python">Documentazione di Python</a></li>
<li class="toctree-l1"><a class="reference internal" href="#estensioni-di-sphinx">Estensioni di Sphinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="glossario.html">Glossario</a></li>
<li class="toctree-l1"><a class="reference internal" href="risorse.html">Risorse</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="scrivere.html" title="capitolo precedente">Scrivere la documentazione</a></li>
      <li>Next: <a href="glossario.html" title="capitolo successivo">Glossario</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Ricerca veloce</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Vai" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, Claudio Driussi.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.0.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/pagine/configurazione.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>